#include "stm8.h"
#include "vectors.h"

unsigned char clock_ms;		/* milliseconds */
unsigned char clock_slow;	/* 1/10 second */

void setup(void);

int main() {
    setup();
    PB_ODR = 0;

    do {

    } while(1);
}

void setup(void)
{
    CLK_CKDIVR = 0x00;	/* clock 16mhz */

    clock_ms = 0;
    clock_slow = 0;

    PB_DDR = 0x20;	/* output LED */
    PB_CR1 = 0xff;     	/* inputs have pullup */
    PB_CR2 = 0x00;	/* no interrupts, 2mhz output */

    TIM4_PSCR = 6;	/* prescaler = 64 */
    TIM4_ARR  = 250;	/* reset and interrupt every 1.0 ms */
    TIM4_CR1  = 1;	/* enable timer4 */
    TIM4_IER  = 1;	/* enable timer4 interrupt */

    __asm__ ("rim");
}
/* Available ports on demo board:
 * A1..A3	A3 is HS
 * B4..B5	Open drain
 * C3..C7	HS
 * D1..D6	HS
 */

void timer4_isr(void) __interrupt (IRQ_TIM4)
{
    TIM4_SR = 0;
    clock_ms++;
    if (clock_ms >= 250) {
	clock_ms -= 250;
	clock_slow++;
	PB_ODR ^= 0x20;
    }
}
